package package1;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import java.sql.*;

public class LastWeek extends HttpServlet {
//Initialize global variables
    int which=0;


  String SERV = "http://sunrise.npac.syr.edu/servlets/";
  public void init(ServletConfig config) throws ServletException {
    super.init(config);
  }
//Service the request

  public void service(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
    //
    int k;
    int index = 0;
    PrintStream out;
    Statement stmt;
    response.setContentType("text/html");
    out = new PrintStream(response.getOutputStream());
    printPageHeader(out, "Results");
    String url = "jdbc:oracle:thin:@sunrise.npac.syr.edu:1521:frog";
    Connection con;
    String id = "pulsar_stat";
    String password = "pulsar";
    String query="";
    ResultSet rs;
    String cut, Current, Till;
    String table_names[];
    table_names= new String[5];

    table_names[0]="wwwstats_table";    	
    table_names[1]="quasarstats_table";
    table_names[2] ="cyberstats_table";
    table_names[3]="mindstats_table";

    try { 
          which = Integer.parseInt(request.getParameter("which"));}
    catch (Exception e) { out.println(e); e.printStackTrace(); }
    

    try {
//	  Current = "to_date('"+day+"','YYYY-MM-DD')";
	  Class.forName("oracle.jdbc.driver.OracleDriver");
          con = DriverManager.getConnection(url, id, password);

	  if (which != 10){	  
          stmt = con.createStatement();

            query="select to_char(day,'YYYY-MM-DD'), count(*) ";
            query+= "from "+table_names[which];
	    query +=" where (to_date(to_char(day, 'YYYY-MM-DD'),'YYYY-MM-DD') >= (SYSDATE-7)) ";
	    query += "group by to_char(day, 'YYYY-MM-DD')";
	    query+= " order by to_char(day, 'YYYY-MM-DD') desc";

       rs = stmt.executeQuery(query);
            //rsmd = rs.getMetaData();
            TableHeader(out);
            while(rs.next()){
            dispResult(rs, out);

            } // end of while
            out.println("</table>");

            stmt.close();

	   }
	   else {
	    out.println("<font color=lime>pulsar-quasar-cyberarium-mindtel</font>");
		
	    for (k=0 ; k <4 ; k++){
		index = 0;
	          stmt = con.createStatement();
		query="select to_char(day,'YYYY-MM-DD'), count(*) ";
		query+= "from "+table_names[k];
		query +=" where (to_date(to_char(day, 'YYYY-MM-DD'),'YYYY-MM-DD') >= (SYSDATE-7)) ";
		query += "group by to_char(day, 'YYYY-MM-DD')";
		query+= " order by to_char(day, 'YYYY-MM-DD') desc";

		rs = stmt.executeQuery(query);
		TableHeader(out);
		while(rs.next()){
		dispResult(rs, out);
		} // end of while
		out.println("</table>");
                stmt.close();
	       	
	    }

	   }
            
	    //PageFooter(out);
            con.close();
          }    //end of try
    catch(SQLException ex){
	out.println(ex);
    }
    catch(java.lang.ClassNotFoundException ex){
	out.println(ex);
    }

  }
//Get Servlet information

  private void dispResult(ResultSet rs, PrintStream out)
    throws SQLException{
    String day = rs.getString(1);
    int counts = rs.getInt(2);

    String t ="<tr><td><font face=arial size=4><a href=\""+SERV+"ShowDay?day="+day+"&which="+which+"\">"+day;
	t +="</a></font></td><td><font face=arial size=4 color=#FFCCCC>"+counts+"</font></td></tr>";
    out.println(t);

  }
  private void TableHeader(PrintStream out){
    String t = "<table width=60% border=2>";
    t += "<tr>";
     t += "<td><b><font color=\"#CCCCFF\" size=5 face=arial>";
	t += "Day</font></td><td><b><font color=\"#CCCCFF\" size=5 face=arial>";
	t += "Number of Requests</font></td></tr>";
    out.println(t);
  }
  public void printPageHeader(PrintStream out, String title){
  String t ="<html><head><title>"+title+"</title></head>\n";
  t += "<body bgcolor=\"#330033\"><center>";
  t += "<p>&nbsp;<b><font face=arial color=#CCCCFF size=5>Log Analysis(last week)";
  t += "</font><p>";
  out.println(t);
  }
public void Footer(PrintStream out){
String t="<hr><p><i>Data is updated every 4 hours</i></body></html>";
out.println(t);
}
  
  
  public String getServletInfo() {
    return "package1.QuickServlet Information";
  }
}

