package package1;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import java.sql.*;

public class QuickMonth extends HttpServlet {
//Initialize global variables
    int which=0;

  String SERV = "http://sunrise.npac.syr.edu/servlets/";
  public void init(ServletConfig config) throws ServletException {
    super.init(config);
  }
//Service the request

  public void service(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
    //
    int k;
    PrintStream out;
    Statement stmt;
    response.setContentType("text/html");
    out = new PrintStream(response.getOutputStream());
    printPageHeader(out, "Results");
    String url = "jdbc:oracle:thin:@sunrise.npac.syr.edu:1521:frog";
    Connection con;
    String id = "pulsar_stat";
    String password = "pulsar";
    String query="";
    ResultSet rs;
    String cut, Current, Till;
    String table_names[];
    table_names= new String[5];
    table_names[0]="wwwstats_table";
    table_names[1]="quasarstats_table";
    table_names[2] ="cyberstats_table";
    table_names[3]="mindstats_table";

    try { 
          which = Integer.parseInt(request.getParameter("which"));}
    catch (Exception e) { e.printStackTrace(); }


    try {
	  Class.forName("oracle.jdbc.driver.OracleDriver");
          con = DriverManager.getConnection(url, id, password);

	  if (which != 10){
          stmt = con.createStatement();
		
            query ="select to_char(day,'YYYY-MM'), count(*) ";
            query += " from "+table_names[which];
	    query += " group by to_char(day,'YYYY-MM') ";
	    query+= " order by to_char(day,'YYYY-MM') desc";
      
            rs = stmt.executeQuery(query);
            //rsmd = rs.getMetaData();
            TableHeader(out);
            while(rs.next()){
            dispResult(rs, out);
            } // end of while
            out.println("</table>");
		stmt.close();
            }
	    else {
		out.println("<font color=lime>pulsar-quasar-cyberarium-mindtel</font>");
		for (k=0 ; k <4 ; k++){
			stmt = con.createStatement();
			query ="select to_char(day,'YYYY-MM'), count(*) ";
			query += " from "+table_names[k];
			query += " group by to_char(day,'YYYY-MM') ";
			query+= " order by to_char(day,'YYYY-MM') desc";
			rs = stmt.executeQuery(query);
			TableHeader(out);
			while(rs.next()){
				dispResult(rs, out);
			}
			out.println("</table>");
			 stmt.close();
		}
	   }

	    PageFooter(out);
            //stmt.close();
            con.close();
          }    //end of try
    catch(SQLException ex){
	out.println(ex);
    }
    catch(java.lang.ClassNotFoundException ex){
	out.println(ex);
    }

  }
//Get Servlet information

  private void dispResult(ResultSet rs, PrintStream out)
    throws SQLException{
    String month = rs.getString(1);
    int counts = rs.getInt(2);
    String t ="<tr><td><font face=arial size=4><a href=\""+SERV+"MtoD?month="+month+"&which="+which+"\">"+month;
	t +="</a></font></td><td><font face=arial size=4 color=#FFCCCC>"+counts+"</font></td></tr>";
    out.println(t);

  }
  private void TableHeader(PrintStream out){
    String t = "<table width=60% border=2>";
    t += "<tr><td><b><font color=\"#CCCCFF\" size=5 face=arial>Month</font></td>";
    t += "<td><b><font color=\"#CCCCFF\" face=arial size=5>";
    t += "Number of Requests</font></b></td></tr>";
    out.println(t);
  }
  public void printPageHeader(PrintStream out, String title){
  String t ="<html><head><title>"+title+"</title></head>\n";
  t += "<body bgcolor=\"#330033\"><center>";
  t += "<p>&nbsp;<b><font face=arial color=#CCCCFF size=5>Log Analysis ";
   t += ":Month and Count Display</font></b><p>";
   out.println(t);
  }

  public void PageFooter(PrintStream out){
	String t ="<p><hr><div align=right><i><font color=#CCCCFF>";
	t += "To view the number of requests by day, click each month<br>";
	t += "After the weekly display, you can view the detailed daily";
	t += " log.</font></div></body></html>";
	out.println(t);
  }

  public String getServletInfo() {
    return "package1.QuickServlet Information";
  }
}

