import java.io.*;
import java.net.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class uploadObject extends HttpServlet
{
       public String[][] parameters = new String[0][0];
       public String[][] files = new String[0][0];

   public uploadObject ( HttpServletRequest req ) throws ServletException, IOException{
       String[] new_files = new String[0];
       Vector input = parseMulti(req);
       Vector params = new Vector();
       String temp;
       String[] input_array = new String[input.size()];
       for (int x = 0; x < input.size(); x++){
            input_array[x] = input.elementAt(x).toString();
       }
       for (int x = 0; x < input_array.length; x++){
           temp = input_array[x];
           if (temp.indexOf("; filename=") != -1){
               files = getFileData(temp,files);
           }
           else parameters = getPostData(temp,parameters);
       }
   }

   public Vector parseMulti ( HttpServletRequest req ) throws ServletException, IOException
   {

      BufferedReader InFile = new BufferedReader(new InputStreamReader(req.getInputStream()));
         Vector v = new Vector();

      try{

         String s = "";
         StringBuffer sb = new StringBuffer();

           // New or changed variables
         int size = req.getContentLength();
         int to_read = (size > 4096) ? 4096 : size;
         int bytes_read = 0;
         char[] b = new char[4096];

         for (int i = 0; i < size; i++) {
           bytes_read = InFile.read(b, 0, to_read);
           if (bytes_read == -1) {
             break;
           }

           i += bytes_read;
           to_read = ((size - i) > 4096) ? 4096 : (size - i);
           s = new String(b);
           sb.append(s.substring(0, bytes_read));
         }


         String indiv_field;
         String delim = "\n-------";
         int loc = 0;
         String input = sb.toString();
         loc = input.indexOf(delim);
         if (loc == -1) indiv_field = input;
         else indiv_field = input.substring(0,loc);
         input = input.substring(loc);
         v.addElement(indiv_field);
         while (input.length() != 0){
            loc = input.indexOf(delim,2);
            if (loc == -1) {indiv_field = input;break;}
            else {
                indiv_field = input.substring(0,loc);
                input = input.substring(loc);
            }
            v.addElement(indiv_field);
         }

      }
      catch(IOException e)
      {
            System.out.println("Error opening RandomAccessFile for writing."+"<br>");
            System.out.println(e.getMessage()+"<br>");
            //System.exit(1);
      }
         return v;
   }

   public String saveFile( String in_file, String filename, boolean use_orig) throws ServletException, IOException
   {
        int p = 0;
        p = in_file.indexOf("\n",p+1);
        p = in_file.indexOf("\n",p+1);
        p = in_file.indexOf("\n",p+1);
        p = in_file.indexOf("\n",p+1);
      String HeaderData=null;

         HeaderData = in_file.substring(0,p);
        in_file = in_file.substring(p + 1);


      // Get the filename out of the header


      int field_loc = HeaderData.indexOf("filename=");
      int first_quote = HeaderData.indexOf("\"",field_loc + 5);
      int last_quote = HeaderData.indexOf("\"",first_quote + 1);
      String FileName = HeaderData.substring(first_quote + 1,last_quote);
      int slash_loc = FileName.lastIndexOf("\\");
      if (slash_loc != -1) FileName = FileName.substring(slash_loc + 1);


      // Now get the footer.
      //It looks something like this '\n-----------------------------46541840611274--\n'

         int TotLen = in_file.length();

         //Look for the footer only in the last 100 bytes.
         int foot_loc = in_file.indexOf("\n-----------", TotLen - 100<0 ?0 :TotLen - 100 );
         int FileLen = foot_loc;
         int FooterLen = TotLen - FileLen;
         String FileData;
         if (TotLen-FooterLen >= 0) FileData = new String( in_file.substring(0,TotLen-FooterLen) );
         else FileData = new String( in_file );
         FileOutputStream fos;
         if (use_orig) fos =  new FileOutputStream(filename + FileName);
         else fos =  new FileOutputStream(filename);
         OutputStreamWriter osw = new OutputStreamWriter( fos );
         Writer OutFile = new BufferedWriter( osw );
         OutFile.write( FileData );
         OutFile.close();
         if (use_orig) return filename + FileName;
         else return filename;

   }

   public String[][] getPostData (String in_data,String[][] in_params) {
       String[][] out_params = new String[in_params.length + 1][2];
       for (int x = 0; x < in_params.length; x++) out_params[x] = in_params[x];
       String[] result = new String[2];
       int loc = in_data.indexOf("name");
       int first_quote = in_data.indexOf("\"",loc);
       int last_quote = in_data.indexOf("\"",first_quote + 1);
       result[0] = in_data.substring(first_quote + 1,last_quote);
       result[1] = in_data.substring(last_quote + 5,in_data.length() - 1);
       out_params[out_params.length - 1] = result;
       return out_params;
   }

   public String[][] getFileData (String in_data,String[][] in_file) {
       String[][] out_file = new String[in_file.length + 1][2];
       for (int x = 0; x < in_file.length; x++) out_file[x] = in_file[x];
       String[] result = new String[2];
       int loc = in_data.indexOf("Content-Type:");
       int end = in_data.indexOf("\n",loc + 14);
       result[0] = in_data.substring(loc + 14,end - 1);
       result[1] = in_data;
       out_file[out_file.length - 1] = result;
       return out_file;
   }
}
