import javax.servlet.http.*;
import javax.servlet.*;
import java.io.*;
import java.sql.*;
import java.lang.*;
public class TngSearch extends HttpServlet {

	//String userid;

	String example;

	public void service(HttpServletRequest req, HttpServletResponse res)
                throws ServletException,IOException{


	Connection con;
	String query ;
	String opt; // search option
	String url = "jdbc:oracle:thin:@sunrise.npac.syr.edu:1521:frog";

	opt  = req.getParameter("opt"); 

        PrintStream out;
	res.setContentType("text/html");
        out = new PrintStream(res.getOutputStream());
        header(out);
	body(out);
	try {

	Class.forName("oracle.jdbc.driver.OracleDriver");

	con = DriverManager.getConnection(url,"quasar","quasar");
	checkForWarning(con.getWarnings(), out);
	Statement stmt = con.createStatement();

	if (opt.equals("date")){  //search everything 

	query="select * from tng3b_table order by serialno";
	ResultSet rs = stmt.executeQuery(query);
	dispResultSet(rs, out);
        }
	else if (opt.equals("author")){  // search by author name
	String author;
	author = req.getParameter("author");
	query = "select * from NT_info_table";
	ResultSet rs = stmt.executeQuery(query);
	dispResultSet2(rs, out,author);
	}
	}
	catch (SQLException ex) {
		out.println("<hr>*** SQLException caught ***<p>");
	}
	catch(java.lang.Exception ex) {
		out.println(ex+"<p>");
	}
	footer(out);

        }

	private void footer(PrintStream out){
                out.println("</body></html>");
                out.flush();
        }

	private void checkForWarning(SQLWarning warn, PrintStream out)
                throws SQLException{
                boolean rc = false;
                if (warn != null) {
                        out.println("<hr>*** Warning ***<p>");
                        rc = true;
                }
        }

	private void header(PrintStream out){
                String h="<html><head><title>\n";
                h+="entire data</title></head>";
                out.println(h);
        }
	
	private void body(PrintStream out){
	String o="<body bgcolor=white>";
	o = "<p><br><center><h3> TNG-3B Serial-Number and Distribution Records";
	o += "</h3></center><p><hr>";
        o += "<p>\n";
	out.println(o);

	}
	private void dispResultSet2(ResultSet rs, PrintStream out,String author) 
		throws SQLException{
		ResultSetMetaData rsmd = rs.getMetaData();
		int numCols = rsmd.getColumnCount();
		String one="<table border=3><tr>\n";
		String str;
		int i;
		one +="<form method=post action=\"http://sunrise.npac.syr.edu/servlet/update_tng\">";
		one += "<th>Update</th>";
		one +="<tr><input type=radio name=update value=";
		for (i=1; i<=numCols; i++) {
		if (rsmd.getColumnLabel(i).equals("NAME") ||
		rsmd.getColumnLabel(i).equals("TYPE") ||
		rsmd.getColumnLabel(i).equals("FUNCTION") ||
		rsmd.getColumnLabel(i).equals("USAGE") ||
		rsmd.getColumnLabel(i).equals("OWNER") ||
		rsmd.getColumnLabel(i).equals("PEOPLE") ||
		rsmd.getColumnLabel(i).equals("DATES"))
			one+="<th>" + rsmd.getColumnLabel(i) + "</th>\n";
		}
		one += "</tr>";
		//out.println(one);
		while (rs.next()) {
		// owner is at the 6th column.
		// now we need to know if owner includes substring, author
		   if ( compare(author, rs.getString(6),out) ){
			one += "<tr>\n";
			

			for (i=1; i<=numCols; i++) {
			if (rsmd.getColumnLabel(i).equals("NAME") ||
			rsmd.getColumnLabel(i).equals("TYPE") ||
			rsmd.getColumnLabel(i).equals("FUNCTION") ||
			rsmd.getColumnLabel(i).equals("USAGE") ||
			rsmd.getColumnLabel(i).equals("PEOPLE") ||
			rsmd.getColumnLabel(i).equals("DATES")){
			   str = rs.getString(i);
			   one += "<th>" + str + "</th>\n";}
			else if (rsmd.getColumnLabel(i).equals("OWNER")){
			   str = rs.getString(i);
			   String st = rs.getString(i+1); //e-mail
			   one +="<th><a HREF=\"mailto:"+st+"\">";
			   one += str+"</a></th>\n";
			}
			}//end of for loop
		   } // end of compare if 
		  
			one +=  "</tr>";	

		}

		   one += "</table>\n";
		   out.println(one);
		
	}

	private boolean compare(String author, String owner,PrintStream out){

		int length1, length2, dif;

		try{
		length1 = owner.length();
		length2 = author.length();
		dif = length1 - length2 ;
				
		if ( (length1 == -1) || (length2 == -1) )
			return false;
		if (length2 > length1)
			return false;  // deo-bol-geo-eop-eum

		if (owner.equals(author))  // such an obvious case.
			return true;
		else if (dif == 0)
			return false;
		     else{	
			for (int j=0 ; j <= dif ; j ++){
			   if(owner.regionMatches(true,j,author,0,length2))
				return true;
			} // end of for loop
			return false;

			} // end of else
		}
		catch(java.lang.Exception ex){
			//out.println(":me!!");
		}	
		return false;
	}
	private void dispResultSet(ResultSet rs, PrintStream out)
		throws SQLException{
		int i;

		ResultSetMetaData rsmd = rs.getMetaData();
		int numCols = rsmd.getColumnCount();
		String one="<table border=3><tr>\n";
		String str;
		one +="<form method=post action=\"http://sunrise.npac.syr.edu/servlet/update_tng\">";
		one += "<th>Update</th>";

		for (i=2; i<=numCols; i++) {
			if (rsmd.getColumnLabel(i).equals("SNH"))
				one+="<th>S&H</th>\n";
			else
				one+="<th>" + rsmd.getColumnLabel(i) + "</th>\n";
			
		}

		one += "</tr>";
		while (rs.next()) {
		
		   
		   one += "<tr>\n";
		   int ids = rs.getInt(1);
		   one += "<th><input type=radio name=update value="+ids+"></th>";
		   for (i=2; i<=numCols; i++) {

			   str = rs.getString(i);
			   one += "<th>" + str + "</th>\n";

		   }
			one +=  "</tr>";
		}

		one += "</table>\n";
		one += "<input type=reset><input type=submit>";
		one += "</form>";
		out.println(one);
	}
/*	
	private void dispElement(ResultSet rs, int dataType,String one,int col)
		throws SQLException{

		switch(dataType) {
			case Types.LONG:
			case Types.VARCHAR2:
			case Types.VARCHAR:
				String str = rs.getString(col);
				one += "<th>" + str + "</th>\n";
				break;
			case Types.NUMBER:
				int integer = rs.getInt(col);
				one += "<th>" + new Integer(integer) + "</th>";
				break;
		}
	}
*/
}
			
