package package1;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import java.sql.*;

public class DateSearch extends HttpServlet {
//Initialize global variables
    int which=0;


  String SERV = "http://sunrise.npac.syr.edu/servlets/";
  public void init(ServletConfig config) throws ServletException {
    super.init(config);
  }
//Service the request

  public void service(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
    //
    String day,till,from,date_one,date_two;
    int k;
    int index = 0;
    PrintStream out;
    Statement stmt;
    response.setContentType("text/html");
    out = new PrintStream(response.getOutputStream());
    printPageHeader(out, "Results");
    String url = "jdbc:oracle:thin:@sunrise.npac.syr.edu:1521:frog";
    Connection con;
    String id = "pulsar_stat";
    String password = "pulsar";
    String query="";
    ResultSet rs;
    String cut, Current, Till;

    String BeginYear="", 
		BeginMonth="", 
		BeginDay="", 
		EndYear="", 
		EndMonth="", 
		EndDay="";

    String table_names[];
    table_names= new String[5];

    table_names[0]="wwwstats_table";    	
    table_names[1]="quasarstats_table";
    table_names[2] ="cyberstats_table";
    table_names[3]="mindstats_table";

    try { 
	  BeginYear	=request.getParameter("yearbegin");
	  BeginMonth    =request.getParameter("monthbegin");
	  BeginDay	=request.getParameter("daybegin");
	  EndYear	=request.getParameter("theyear");
	  EndMonth	=request.getParameter("themonth");
	  EndDay	=request.getParameter("theday");	  
          which 	= Integer.parseInt(request.getParameter("server"));}
    catch (Exception e) { out.println(e); e.printStackTrace(); }
    

    try {
	  date_one = BeginYear+"-"+BeginMonth+"-"+BeginDay;
	  date_two = EndYear+"-"+EndMonth+"-"+EndDay;

	  from = "to_date('"+date_one+"','YYYY-MM-DD')";
	  till = "to_date('"+date_two+"','YYYY-MM-DD')";
 
	  Class.forName("oracle.jdbc.driver.OracleDriver");
          con = DriverManager.getConnection(url, id, password);

	  if (which != 10){	  
          stmt = con.createStatement();
	  query="select to_char(day,'YYYY-MM-DD'), count(*) ";
	  query+= "from "+table_names[which]+" where ((day >="+ from+") and (day<="+till+"))";
	  query += " group by to_char(day,'YYYY-MM-DD')";
	  query+= " order by to_char(day,'YYYY-MM-DD') desc";

       rs = stmt.executeQuery(query);
            //rsmd = rs.getMetaData();
            TableHeader(out);
            while(rs.next()){
	    index ++ ;
            dispResult(rs, out, index);

            } // end of while
            out.println("</table>");

            stmt.close();

	   }
	   else {
	    out.println("<font color=lime>pulsar-quasar-cyberarium-mindtel</font>");
		
	    for (k=0 ; k <4 ; k++){
		index = 0;
	          stmt = con.createStatement();

		query="select to_char(day,'YYYY-MM-DD'), count(*) ";
		query+= "from "+table_names[k]+" where ((day >="+ from+") and (day<="+till+"))";
		query += " group by to_char(day,'YYYY-MM-DD')";
		query+= " order by to_char(day,'YYYY-MM-DD') desc";

		rs = stmt.executeQuery(query);
		TableHeader(out);
		while(rs.next()){
		index ++;
		dispResult(rs, out, index);
		} // end of while
		out.println("</table>");
                stmt.close();
	       	
	    }

	   }
            
	    //PageFooter(out);
            con.close();
          }    //end of try
    catch(SQLException ex){
	out.println(ex+"<p>");
	out.println("<font color=yellow>SQL error occurred as above<br>");
	out.println("Probably dates information are not valid<br>");
	out.println("Please try again and make sure dates information is correct.<p>");
	out.println("</font>");	
    }
    catch(java.lang.ClassNotFoundException ex){
	out.println(ex);
    }

  }
//Get Servlet information

  private void dispResult(ResultSet rs, PrintStream out, int index)
    throws SQLException{
	String day = rs.getString(1);
	int counts = rs.getInt(2);
	String t ="<tr><td><font face=arial size=4><a href=\""+SERV+"ShowDay?day="+day+"&which="+which+"\">"+day;
	t +="</a></font></td><td><font face=arial size=4 color=#FFCCCC>"+counts+"</font></td></tr>";
	


    out.println(t);

  }
  private void TableHeader(PrintStream out){
    String t = "<table width=60% border=2>";
	t += "<tr><td><b><font color=\"#CCCCFF\" size=5 face=arial>Month</font></b></td>";
	t += "<td><b><font color=\"#CCCCFF\" face=arial size=5>";
	t += "Number of Requests</font></b></td></tr>";

    out.println(t);
  }
  public void printPageHeader(PrintStream out, String title){
  String t ="<html><head><title>"+title+"</title></head>\n";
  t += "<body bgcolor=\"#330033\"><center>";
  t += "<p>&nbsp;<b><font face=arial color=#CCCCFF size=4>Web Server Statistics";
  t += "</font><p>";
  out.println(t);
  }
public void Footer(PrintStream out){
String t="<hr><p><i>Data is updated every 4 hours</i></body></html>";
out.println(t);
}
  
  
  public String getServletInfo() {
    return "package1.QuickServlet Information";
  }
}

